<template>
  <b-container>
    <div class="background_bloc h-100" />
    <h1 class="title">
      S'inscrire
    </h1>
    <p>{{ error }}</p>
    <div>
      <label for="avatar">Image profil *</label>
      <input
        id="avatar"
        type="file"
        name="avatar"
        accept="image/png, image/jpeg"
        @change="onFileUpload($event)"
      >
    </div>
    <b-form>
      <div class="d-flex">
        <img
          :src="require('@/assets/icones/user.png')"
          alt=""
        >
      </div>
      <div class="d-flex">
        <b-form-group class="w-100">
          <label>Nom *</label>
          <b-form-input
            v-model="nom"
            type="text"
            required
          />
        </b-form-group>
        <b-form-group class="w-100">
          <label>Prénom *</label>
          <b-form-input
            v-model="prenom"
            type="text"
            required
          />
        </b-form-group>
      </div>
      <b-form-group>
        <label for="feedback-pseudo">Pseudo *</label>
        <b-form-input
          v-model="pseudo"
          type="text"
          required
        />
      </b-form-group>
      <!-- <b-form-input type="text" v-model="pseudo" :state="validationPseudo" id="feedback-pseudo" required></b-form-input> -->
      <!-- <b-form-input type="text" v-model="pseudo" id="feedback-pseudo" required></b-form-input> -->
      <!-- <b-form-invalid-feedback :state="validationPseudo"> -->
      <b-form-group>
        <label>Email *</label>
        <b-form-input
          v-model="email"
          type="email"
          required
        />
      </b-form-group>
      <b-form-group>
        <label for="feedback-password">Mot de passe *</label>
        <b-form-input
          v-model="password"
          type="password"
          required
        />
      </b-form-group>
      <!-- <b-form-input type="text" v-model="password" :state="validationMdp" id="feedback-password" required></b-form-input> -->
      <!-- <b-form-input type="text" v-model="password" id="feedback-password" required></b-form-input> -->
      <!-- <b-form-invalid-feedback :state="validationMdp"> -->
      <div class="d-flex">
        <b-form-group class="w-100">
          <label>Code Postal *</label>  
          <b-form-input
            v-model="code_postal"
            type="number"
            required
          />
        </b-form-group>
        <b-form-group class="w-100">
          <label>Ville *</label>  
          <b-form-input
            v-model="ville"
            type="text"
            required
          />    
        </b-form-group>
      </div>
      <b-form-group>
        <label>Adresse *</label>  
        <b-form-input
          v-model="adresse"
          type="text"
          required
        />
      </b-form-group>
      <div>
        <input
          v-model="terms"
          type="checkbox"
          required
        >
        <label>Je ne suis pas un robot (recapcha)</label>
      </div>

      <div class="button d-flex justify-content-end">
        <button
          class="submit btn-cta "
          type="submit"
          @click.prevent="adduser($event)"
        >
          Enregistrer
        </button>
      </div>
    </b-form>
  </b-container>
  <Modal
    ref="modalMsg"
    :message="message"
    :choix="false"
  />
</template>
<script>
import axios from 'axios';
import Modal from '@/components/Modal.vue';

 export default {

    components: {
      Modal
    },

    data() {
        return {
            error: '',
            nom: '',
            prenom: '',
            pseudo: '',
            email: '',
            password: '',
            code_postal: '',
            ville: '',
            adresse: '',
            FILE: null,
            message: '',
            avatar: ''
        }
    },
    // computed: {
    //   validationMdp() {
    //     return this.nom.length > 7
    //   }, 
    //  // if pseudo is available or not
    //    validationPseudo() {
    //      axios.get(url + "/api/utilisateurs")
    //      .then(response => {
    //          this.posts = response.data;
    //      })
    //      return this.nom.length > 7
    //    }
    //  },
     methods: {

        onFileUpload(event) {
            this.FILE = event.target.files[0]
        },

        adduser() {

            const url = process.env.VUE_APP_URL;

            // const formData = new FormData();
            // formData.append('file',this.FILE);
            // formData.append('avatar', this.FILE, this.FILE.name)
            // formData.append('name', this.name)

            axios.post(url + "/api/utilisateurs", {
                "profil": "api/profils/2",
                "nom": this.nom,
                "prenom": this.prenom,
                "pseudo": this.pseudo,
                "email": this.email,
                "password": this.password,
                "codePostal": this.code_postal,
                "ville": this.ville,
                "adresse": this.adresse,
                "nombreAchat": 0,
            })
            .then(response => {
                console.log(response.data['@id']);
                if(this.FILE !== null){
                    axios.post(url + "/api/utilisateurs/avatar", {
                        "utilisateur_id": response.data.id,
                        "file": this.FILE,
                    },
                    {
                        headers: {
                                "Content-Type": "multipart/form-data",
                                "Access-Control-Allow-Origin": "*"
                        }
                    })
                    .then(response => {
                        console.log(response.data)
                    })
                    .catch(err => {
                        this.error =  err.response.data['hydra:description'];
                        console.log(idUser);
                        console.log(err);
                    })  
                }
                this.$router.push('/connexion');
            })
            .catch(err => {
                console.log(err);
                if(err.response.data){
                    if( err.response.data['hydra:description']){
                        this.message = err.response.data['hydra:description'];
                    }
                } else {
                    this.message = err.response.data;
                }
                this.$refs.modalMsg.show = true;
                console.log(err);
            })
        }
     }
 }
</script>
